<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
  	extension-element-prefixes="redirect">

	<xsl:import href="xradar://stylesheets/radar/statics/report/framework/master-report-presentation.xsl"/>


<xsl:template name="packages-snapshot">
	<xsl:param name="packages-element"/>

			<redirect:write file="{$docs-home}/analysis/package-by-name.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by name'"/>
					<xsl:with-param name="table-id" select="'package-by-name'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-ncss.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by ncss'"/>
					<xsl:with-param name="table-id" select="'package-by-ncss'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-ccn.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by ccn'"/>
					<xsl:with-param name="table-id" select="'package-by-ccn'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-violations.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by violations'"/>
					<xsl:with-param name="table-id" select="'package-by-violations'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-style-errors.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by style errors'"/>
					<xsl:with-param name="table-id" select="'package-by-style-errors'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-duplications.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by duplications'"/>
					<xsl:with-param name="table-id" select="'package-by-duplications'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-distance.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by distance'"/>
					<xsl:with-param name="table-id" select="'package-by-distance'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-cep.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by efferent couplings'"/>
					<xsl:with-param name="table-id" select="'package-by-cep'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-cap.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by afferent couplings'"/>
					<xsl:with-param name="table-id" select="'package-by-cap'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-cbo.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by cbo'"/>
					<xsl:with-param name="table-id" select="'package-by-cbo'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-ca.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by ca'"/>
					<xsl:with-param name="table-id" select="'package-by-ca'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-rfc.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by rfc'"/>
					<xsl:with-param name="table-id" select="'package-by-rfc'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-lcom.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by lcom'"/>
					<xsl:with-param name="table-id" select="'package-by-lcom'"/>
		    	</xsl:call-template>
	   		</redirect:write>
			<redirect:write file="{$docs-home}/img/analysis/package-by-dit.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by dit'"/>
					<xsl:with-param name="table-id" select="'package-by-dit'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/img/analysis/package-by-tsc.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by tsc'"/>
					<xsl:with-param name="table-id" select="'package-by-tsc'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/img/analysis/package-by-tmr.html">
		    	<xsl:call-template name="package">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by tmr'"/>
					<xsl:with-param name="table-id" select="'package-by-tmr'"/>
		    	</xsl:call-template>
	   		</redirect:write>

</xsl:template>

<xsl:template name="package">
	<xsl:param name="packages-element"/>
	<xsl:param name="table-type"/>
	<xsl:param name="table-id"/>

   <html>
      <head>
          <link rel="stylesheet" type="text/css" href="../stylesheet.css"/>
      </head>
      <body>
        <xsl:call-template name="page-header">
  	  		<xsl:with-param name="main-menu-page-name" select="'analysis'"/>
  	  		<xsl:with-param name="page-name" select="'package analysis'"/>
  	  		<xsl:with-param name="root-element" select=".."/>
  	  		<xsl:with-param name="path-to-root" select="'../'"/>
  	    </xsl:call-template>
  	 <br/>
  	 Press header links to alter sort criteria.
  	 <br/>
  	 <table class="details" width="100%">
  	 	<tr>
			<th><a href="package-by-name.html">Package</a></th>
			  <th><a href="package-by-ncss.html">Source statements</a></th>
			  <th><a href="package-by-ccn.html">Cyclometic complexity</a></th>
			  <th><a href="package-by-violations.html">Violations</a></th>
			  <th><a href="package-by-style-errors.html">Style Errors</a></th>
			  <th><a href="package-by-duplications.html">Duplications</a></th>
			  <th><a href="package-by-distance.html">Distance</a></th>
			  <th><a href="package-by-cep.html">Efferent Package Couplings</a></th>
			  <th><a href="package-by-cap.html">Afferent Package Couplings</a></th>
			  <th><a href="package-by-cbo.html">Efferent (Import) Class Couplings (CBO / Ce)</a></th>
			  <th><a href="package-by-ca.html">Afferent (Emport) Class Couplings (CBO / Ca)</a></th>
			  <th><a href="package-by-rfc.html">Response for Class (RFC)</a></th>
			  <th><a href="package-by-lcom.html">Lack of Cohesion in Methods (LCOM)</a></th>
			  <th><a href="package-by-dit.html">Depth of Inheritance Rree (DIT)</a></th>
			  <th><a href="package-by-tsc.html">Statement Test Coverage</a></th>
			  <th><a href="package-by-tmr.html">Method Test Reference</a></th>
		</tr>
  	 	<xsl:choose>
	  	 	<xsl:when test="$table-id='package-by-name'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="@name"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-ncss'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/ncss" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-ccn'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/ccn" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-violations'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/code-violations" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-style-errors'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/style-errors" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-duplications'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="sum(Stats/duplication-metrics/duplications)"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-distance'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/D" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-cep'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/Ce" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-cap'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/Ca" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-cbo'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/oo-metrics/cbo" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-ca'">
	  	 		<xsl:for-each select="$packages-element/Package">
		  	 		<xsl:sort select="Stats/oo-metrics/ca" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-rfc'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/oo-metrics/rfc" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-lcom'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/oo-metrics/lcom" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-dit'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="Stats/oo-metrics/dit" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-tsc'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="sum(Stats/test-metrics/source-statements-covered) div sum(Stats/ncss)" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='package-by-tmr'">
	  	 		<xsl:for-each select="$packages-element/Package[count(error) = 0]">
		  	 		<xsl:sort select="sum(Stats/test-metrics/methods-referenced) div sum(Stats/oo-metrics/npm)" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-package-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
		</xsl:choose>
  	 </table>

  	</body>
  </html>
</xsl:template>

</xsl:stylesheet>
